Subject: [bug#68942] [PATCH] grafts: rename files in deepest-first order.

From: [email-masked]
Date: Tue, 06 Feb 2024 01:06:38 +0000

From: Skyler Ferris <[email-masked]>

The problem is explained in the deleted comment. The fix is just
to reverse the list given to for-each. I guess this is correct
because the procedure does not depend on parallel ordering between
different lists, it uses assoc-ref to look things up. It fixed the
problem when I ran into this bug while working on a package.

Change-Id: I997880043f35797ad79ffd73a02b5ffdd9283da9
---
# While I do not have the resources to test this exhaustively (ie,
# rebuild all of the packages defined by guix), I successfully
# reconfigured my system to use a version of guix with this patch
# included, and the output showed that at least dozens of grafts were
# applied successfully. Additionally, the tests in `tests/grafts.scm`
# pass. If anything needs to be improved please let me know and I will
# work on a different patch to resolve this issue.
 guix/build/graft.scm | 6 +-----
 1 file changed, 1 insertion(+), 5 deletions(-)

diff --git a/guix/build/graft.scm b/guix/build/graft.scm
index 281dbaba6f..232c2a04ad 100644
--- a/guix/build/graft.scm
+++ b/guix/build/graft.scm
@@ -289,15 +289,11 @@ (define (rename-matching-files directory mapping)
                                 (assoc-ref mapping (basename file)))
                               #:directories? #t)))
 
-    ;; XXX: This is not quite correct: if MAPPING contains "foo", and
-    ;; DIRECTORY contains "bar/foo/foo", we first rename "bar/foo" and then
-    ;; "bar/foo/foo" no longer exists so we fail.  Oh well, surely that's good
-    ;; enough!
     (for-each (lambda (file)
                 (let ((target (assoc-ref mapping (basename file))))
                   (rename-file file
                                (string-append (dirname file) "/" target))))
-              matches)))
+              (reverse matches))))
 
 (define (exit-on-exception proc)
   "Return a procedure that wraps PROC so that 'primitive-exit' is called when

base-commit: 931d893c550128591018587c90d2491fd66a11a4
-- 
2.41.0